Attribute VB_Name = "modMain"
Option Explicit
'---------------------------------------------------------------
'- Registry Api Constants...
'---------------------------------------------------------------
' Reg Data Types...
Const REG_SZ = 1                         ' Unicode nul terminated string
Const REG_EXPAND_SZ = 2                  ' Unicode nul terminated string
Const REG_DWORD = 4                      ' 32-bit number

' Reg Create Type Values...
Const REG_OPTION_NON_VOLATILE = 0       ' Key is preserved when system is rebooted

' Reg Key Security Options...
Const READ_CONTROL = &H20000
Const KEY_QUERY_VALUE = &H1
Const KEY_SET_VALUE = &H2
Const KEY_CREATE_SUB_KEY = &H4
Const KEY_ENUMERATE_SUB_KEYS = &H8
Const KEY_NOTIFY = &H10
Const KEY_CREATE_LINK = &H20
Const KEY_READ = KEY_QUERY_VALUE + KEY_ENUMERATE_SUB_KEYS + KEY_NOTIFY + READ_CONTROL
Const KEY_WRITE = KEY_SET_VALUE + KEY_CREATE_SUB_KEY + READ_CONTROL
Const KEY_EXECUTE = KEY_READ
Const KEY_ALL_ACCESS = KEY_QUERY_VALUE + KEY_SET_VALUE + _
                       KEY_CREATE_SUB_KEY + KEY_ENUMERATE_SUB_KEYS + _
                       KEY_NOTIFY + KEY_CREATE_LINK + READ_CONTROL
                     
' Reg Key ROOT Types...
Const HKEY_CLASSES_ROOT = &H80000000
Const HKEY_CURRENT_USER = &H80000001
Global Const HKEY_LOCAL_MACHINE = &H80000002
Const HKEY_USERS = &H80000003
Const HKEY_PERFORMANCE_DATA = &H80000004

' Return Value...
Const ERROR_NONE = 0
Const ERROR_BADKEY = 2
Public Const ERROR_SUCCESS = 0
Public Const ERROR_BADDB = 1
Public Const ERROR_CANTOPEN = 3
Public Const ERROR_CANTREAD = 4
Public Const ERROR_CANTWRITE = 5
Public Const ERROR_OUTOFMEMORY = 6
Public Const ERROR_ARENA_TRASHED = 7
Public Const ERROR_ACCESS_DENIED = 8
Public Const ERROR_INVALID_PARAMETERS = 87
Public Const ERROR_NO_MORE_ITEMS = 259

Public Const BUFFER_SIZE As Long = 255


'---------------------------------------------------------------
'- Registry Security Attributes TYPE...
'---------------------------------------------------------------
Private Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Boolean
End Type

Private Const S_OK = 0 ' return value from CoCreateGuid

Private Declare Function GetComputerName Lib "Kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValueExNULL Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As Long, lpcbData As Long) As Long
Private Declare Function RegQueryValueExString Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegQueryValueExLong Lib "advapi32.dll" Alias _
   "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As _
   String, ByVal lpReserved As Long, lpType As Long, lpData As _
   Long, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByRef lpSecurityAttributes As SECURITY_ATTRIBUTES, ByRef phkResult As Long, ByRef lpdwDisposition As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, ByRef lpType As Long, ByVal lpData As String, ByRef lpcbData As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Private Declare Function RegSetValueExLong Lib "advapi32.dll" Alias _
   "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, _
   ByVal Reserved As Long, ByVal dwType As Long, lpValue As Long, _
   ByVal cbData As Long) As Long
   
Public Declare Function RegEnumKeyEx Lib "advapi32.dll" _
    Alias "RegEnumKeyExA" ( _
    ByVal hKey As Long, _
    ByVal dwIndex As Long, _
    ByVal lpName As String, _
    lpcbName As Long, _
    ByVal lpReserved As Long, _
    ByVal lpClass As String, _
    lpcbClass As Long, _
    lpftLastWriteTime As Any) As Long


Function GetRegistryString(ByVal sKeyName As String, ByVal szValueName As String, Optional sServer As String) As String
    On Error Resume Next
    Dim cch As Long
    Dim lrc As Long
    Dim lType As Long
    Dim lRetVal As Long
    Dim hKey As Long
    Dim sValue As String
    Dim lValue As Long
    
    lRetVal = RegOpenKeyEx(HKEY_LOCAL_MACHINE, sKeyName, 0, KEY_ALL_ACCESS, hKey)
    lrc = RegQueryValueExNULL(hKey, szValueName, 0&, lType, 0&, cch)
    sValue = String(cch, 0)
    Select Case lType
        Case REG_DWORD
            lrc = RegQueryValueExLong(hKey, szValueName, 0&, lType, lValue, cch)
            GetRegistryString = lValue
        Case Else
            lrc = RegQueryValueExString(hKey, szValueName, 0&, lType, sValue, cch)
            GetRegistryString = Left$(sValue, cch - 1)
        
    End Select
    RegCloseKey (hKey)
End Function

'-------------------------------------------------------------------------------------------------
'sample usage - Debug.Print UpodateKey(HKEY_CLASSES_ROOT, "keyname", "newvalue")
'-------------------------------------------------------------------------------------------------
Public Function UpdateKey(KeyRoot As Long, KeyName As String, SubKeyName As String, SubKeyValue As String, lType As Long) As Boolean
    Dim rc As Long                                      ' Return Code
    Dim hKey As Long                                    ' Handle To A Registry Key
    Dim hDepth As Long                                  '
    Dim lpAttr As SECURITY_ATTRIBUTES                   ' Registry Security Type
    Dim lValue As Long
    
    lpAttr.nLength = 50                                 ' Set Security Attributes To Defaults...
    lpAttr.lpSecurityDescriptor = 0                     ' ...
    lpAttr.bInheritHandle = True                        ' ...

    '------------------------------------------------------------
    '- Create/Open Registry Key...
    '------------------------------------------------------------
    rc = RegCreateKeyEx(KeyRoot, KeyName, _
                        0, REG_SZ, _
                        REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, lpAttr, _
                        hKey, hDepth)                   ' Create/Open //KeyRoot//KeyName
    
    If (rc <> ERROR_SUCCESS) Then GoTo CreateKeyError   ' Handle Errors...
    
    '------------------------------------------------------------
    '- Create/Modify Key Value...
    '------------------------------------------------------------
    If (SubKeyValue = "") Then SubKeyValue = Chr$(0)        ' A Space Is Needed For RegSetValueEx() To Work...
    
    ' Create/Modify Key Value
    Select Case lType
    Case REG_DWORD
        lValue = SubKeyValue
        rc = RegSetValueExLong(hKey, SubKeyName, 0&, lType, lValue, 4)
    Case Else
        rc = RegSetValueEx(hKey, SubKeyName, 0, lType, SubKeyValue, LenB(StrConv(SubKeyValue, vbFromUnicode)))
    End Select
    
    If (rc <> ERROR_SUCCESS) Then GoTo CreateKeyError   ' Handle Error
    '------------------------------------------------------------
    '- Close Registry Key...
    '------------------------------------------------------------
    rc = RegCloseKey(hKey)                              ' Close Key
    
    UpdateKey = True                                    ' Return Success
    Exit Function                                       ' Exit
CreateKeyError:
    UpdateKey = False                                   ' Set Error Return Code
    rc = RegCloseKey(hKey)                              ' Attempt To Close Key
End Function

'-------------------------------------------------------------------------------------------------
'sample usage - Debug.Print GetKeyValue(HKEY_CLASSES_ROOT, "COMCTL.ListviewCtrl.1\CLSID", "")
'-------------------------------------------------------------------------------------------------
Public Function GetKeyValue(KeyRoot As Long, KeyName As String, SubKeyRef As String) As String
    Dim i As Long                                           ' Loop Counter
    Dim rc As Long                                          ' Return Code
    Dim hKey As Long                                        ' Handle To An Open Registry Key
    Dim hDepth As Long                                      '
    Dim sKeyVal As String
    Dim lKeyValType As Long                                 ' Data Type Of A Registry Key
    Dim tmpVal As String                                    ' Tempory Storage For A Registry Key Value
    Dim KeyValSize As Long                                  ' Size Of Registry Key Variable
    
    ' Open RegKey Under KeyRoot {HKEY_LOCAL_MACHINE...}
    '------------------------------------------------------------
    rc = RegOpenKeyEx(KeyRoot, KeyName, 0, KEY_ALL_ACCESS, hKey) ' Open Registry Key
    
    If (rc <> ERROR_SUCCESS) Then GoTo GetKeyError          ' Handle Error...
    
    tmpVal = String$(1024, 0)                             ' Allocate Variable Space
    KeyValSize = 1024                                       ' Mark Variable Size
    
    '------------------------------------------------------------
    ' Retrieve Registry Key Value...
    '------------------------------------------------------------
    rc = RegQueryValueEx(hKey, SubKeyRef, 0, _
                         lKeyValType, tmpVal, KeyValSize)     ' Get/Create Key Value
                        
    If (rc <> ERROR_SUCCESS) Then GoTo GetKeyError          ' Handle Errors
      
    tmpVal = Left$(tmpVal, InStr(tmpVal, Chr(0)) - 1)

    '------------------------------------------------------------
    ' Determine Key Value Type For Conversion...
    '------------------------------------------------------------
    Select Case lKeyValType                                  ' Search Data Types...
    Case REG_SZ, REG_EXPAND_SZ                              ' String Registry Key Data Type
        sKeyVal = tmpVal                                     ' Copy String Value
    Case REG_DWORD                                          ' Double Word Registry Key Data Type
        For i = Len(tmpVal) To 1 Step -1                    ' Convert Each Bit
            sKeyVal = sKeyVal + Hex(Asc(Mid(tmpVal, i, 1)))   ' Build Value Char. By Char.
        Next
        sKeyVal = Format$("&h" + sKeyVal)                     ' Convert Double Word To String
    End Select
    
    GetKeyValue = sKeyVal                                   ' Return Value
    rc = RegCloseKey(hKey)                                  ' Close Registry Key
    Exit Function                                           ' Exit
    
GetKeyError:    ' Cleanup After An Error Has Occured...
    GetKeyValue = vbNullString                              ' Set Return Val To Empty String
    rc = RegCloseKey(hKey)                                  ' Close Registry Key
End Function




Public Function CreateMailbox(sPostoffice As String, sMailbox As String, sPassword As String, lQuota As Long, sMailRoot As String, Optional sRights = "USER")

    On Error GoTo errHandler
    
    Dim oMailbox As Object
    Dim oAUTHLogin As Object
    Dim lResult As Long
    
    Set oAUTHLogin = CreateObject("MEAOAU.Login")
    Set oMailbox = CreateObject("MEAOPO.Mailbox")

    With oMailbox
        .Postoffice = sPostoffice
        .Mailbox = sMailbox
        .Limit = lQuota
        .RedirectAddress = ""
        .RedirectStatus = 0
        .Status = 1
        lResult = oMailbox.AddMailbox()
    End With
    
    'when we create a mailbox we also create a pop logon
    With oAUTHLogin
        .Account = sPostoffice
        .Description = ""
        .Password = sPassword
        .Rights = sRights
        .Status = 1
        .UserName = sMailbox & "@" & sPostoffice
    End With
        
    lResult = oAUTHLogin.AddLogin()
    
    'we have to create the directory as well
    Dim oFSO As New FileSystemObject
    
    'is the post office there?
    If Not oFSO.FolderExists(sMailRoot & "\" & sPostoffice) Then
        oFSO.CreateFolder sMailRoot & "\" & sPostoffice
    End If
    
    'is the mailroot there?
    If Not oFSO.FolderExists(sMailRoot & "\" & sPostoffice & "\mailroot") Then
        oFSO.CreateFolder sMailRoot & "\" & sPostoffice & "\mailroot"
    End If
    
    If Not oFSO.FolderExists(sMailRoot & "\" & sPostoffice & "\mailroot\" & sMailbox) Then
        oFSO.CreateFolder sMailRoot & "\" & sPostoffice & "\mailroot\" & sMailbox
    End If
    
    'also create the inbox
    If Not oFSO.FolderExists(sMailRoot & "\" & sPostoffice & "\mailroot\" & sMailbox & "\inbox") Then
        oFSO.CreateFolder sMailRoot & "\" & sPostoffice & "\mailroot\" & sMailbox & "\inbox"
    End If
    
    Exit Function
    
errHandler:
    MsgBox "CreateMailbox:" & Err.Description
End Function


Public Function GetListItem(ItemList, Delimiter, ItemNumber) As String

    'gets the specific item from a delimited list
    'if there is an error then it will return blank, but also false
    
    Dim sItems

    On Error Resume Next            'there is an error
    sItems = Split(ItemList, Delimiter)
    GetListItem = sItems(ItemNumber - 1)
    
End Function

Public Function CreateMapping(sType As String, sAddress As String, sPostoffice As String, sMailbox As String)
    
    'add this to the file
    Dim oAddressMap As Object
    Dim lResult As Long
    
    Set oAddressMap = CreateObject("MEAOAM.AddressMap")
    
    With oAddressMap
        .Account = sPostoffice
        'destination is this mailbox
        'type can be SF or LS
        .DestinationAddress = "[" & sType & ":" & sPostoffice & "/" & sMailbox & "]"
        .Scope = ""
        .SourceAddress = "[SMTP:" & sAddress & "]"
        lResult = oAddressMap.AddAddressMap()
    End With
        
End Function


Public Function MappingExists(sAddress As String, sAccount As String) As Boolean

    'checks to see if a mapping exists
    
    Dim oAddressMap As Object
    Dim lResult As Long
    
    Set oAddressMap = CreateObject("MEAOAM.AddressMap")
    With oAddressMap
        .Account = ""
        .DestinationAddress = ""        'don't care where it goes, each source has to be unique
        .Scope = ""
        .SourceAddress = "[SMTP:" & sAddress & "]"
    End With
        
    lResult = oAddressMap.GetAddressMap()
    
    If lResult = 0 Then
        MappingExists = False
    Else
        MappingExists = True
    End If
        
End Function

Public Function MailboxExists(sMailbox As String, ByRef sAccount As String) As Boolean

    Dim oMailbox As Object
    Dim lResult As Long
    
    Set oMailbox = CreateObject("MEAOPO.Mailbox")
    
    With oMailbox
        .Postoffice = sAccount
        .Mailbox = sMailbox
        .Limit = -1
        .RedirectAddress = ""
        .RedirectStatus = -1
        .Status = -1
        lResult = oMailbox.GetMailbox()
    End With
              
    If lResult = 0 Then
        'not valid
        MailboxExists = False
    Else
        MailboxExists = True
    End If
    
End Function


Public Function DomainExists(sDomain As String, ByRef sAccount As String) As Boolean

    Dim oDomain As Object
    Dim lResult As Long
    
    Set oDomain = CreateObject("MEAOSM.Domain")
    
    With oDomain
        .AccountName = ""
        .DomainName = sDomain
        .DomainRedirectionHosts = ""
        .DomainRedirectionStatus = -1
        .Status = -1
    End With
        
    lResult = oDomain.GetDomain()
      
    If lResult = 0 Then
        'not valid
        DomainExists = False
    Else
        DomainExists = True
        sAccount = oDomain.AccountName
    End If
    
End Function

Public Function CreateDomain(sDomain As String, sAccount As String)

    Dim oDomain As Object
    Dim lResult As Long
    
    Set oDomain = CreateObject("MEAOSM.Domain")
    
    With oDomain
        .AccountName = sAccount
        .DomainName = sDomain
        .DomainRedirectionHosts = ""
        .DomainRedirectionStatus = 0
        .Status = 1
        lResult = oDomain.AddDomain()
    End With

End Function


Public Function GetMailEnableDirectory() As String
    On Error Resume Next
    'use the data directory, not the program directory key
    GetMailEnableDirectory = GetRegistryString("SOFTWARE\Mail Enable\Mail Enable", "Data Directory")
    
End Function


Public Function DeleteMailbox(sPostoffice As String, sMailbox As String)
   'delete a mailbox
    On Error GoTo errHandler
    
    Dim oFSO As Object          'New FileSystemObject
    
    Set oFSO = CreateObject("Scripting.FileSystemObject")
    
    'delete the selected mailbox
    
    'todo retry this in case the mailbox is in use
    If oFSO.FolderExists(GetMailEnableDirectory & "\" & sPostoffice & "\mailroot\" & sMailbox) Then
        On Error Resume Next
        oFSO.DeleteFolder GetMailEnableDirectory & "\" & sPostoffice & "\mailroot\" & sMailbox, True
        If Err.Number <> 0 Then
            MsgBox "The " & sMailbox & " mailbox is in use and cannot be deleted. Disable the " & vbCrLf & _
                "mailbox to make sure it can't be used. You will also need to wait until the current user disconnects."
            Exit Function
        End If
        On Error GoTo errHandler
    End If
    
    Dim oMailbox As Object
    Dim lResult As Long
    
    Set oMailbox = CreateObject("MEAOPO.Mailbox")

    With oMailbox
        .Postoffice = sPostoffice
        .Mailbox = sMailbox
        .Limit = 0
        .RedirectAddress = ""
        .RedirectStatus = 0
        .Size = 0
        lResult = .RemoveMailbox()
    End With
    
    'remove mapping from address-map
    DeleteMapping "[SF:" & sPostoffice & "/" & sMailbox & "]", sPostoffice

    'remove auth
    RemoveAuth sPostoffice, sMailbox & "@" & sPostoffice
        
    Exit Function
    
errHandler:
    MsgBox Err.Description
End Function


Public Function DeleteMapping(sDestination As String, sPostoffice As String)

    'remove an address map
    Dim oAddressMap As Object
    Dim lResult As Long
    
    Set oAddressMap = CreateObject("MEAOAM.AddressMap")

    'first we get the old one
    With oAddressMap
        .Account = sPostoffice
        .DestinationAddress = sDestination
        .Scope = ""
        .SourceAddress = ""
        lResult = .RemoveAddressMap()
    End With
       
    'cos lresult will be 0 if it doesn't delete anything, which may happen if no destination specified
    If lResult = 0 And Len(sDestination) > 0 Then
       ' MsgBox "Failed to remove map."
        Exit Function
    End If
            
    Exit Function
    
errHandler:
    MsgBox "Error:DeleteMapping: " & Err.Description
End Function

Public Function RemoveAuth(sPostoffice As String, sUser As String)

    'returns the password for a user
    'this is located in the POPAccounts.tab file
    
    Dim oAUTHLogin As Object
    Dim lResult As Long
    
    Set oAUTHLogin = CreateObject("MEAOAU.Login")
    
    With oAUTHLogin
        .Account = sPostoffice
        .Password = ""
        .Status = -1
        .UserName = sUser
        .Description = ""
        lResult = .RemoveLogin()
    End With
    
    
    Exit Function
    
errHandler:
    'file problem usually..
    MsgBox "Could not delete auth entry."
End Function

